#lang racket
(require "syntax-procs.rkt")
(require rackunit)

;; ---------------------------------------------------------------------
;; tree-count

(define tree-count
  (lambda (test? tree)
    (if (number? tree)
        (if (test? tree) 1 0)
        (+ (if (test? (first tree)) 1 0)
           (tree-count test? (second tree))
           (tree-count test? (third tree))))))

;; ---------------------------------------------------------------------
;; annotate

(define annotate
  (lambda (prefix-exp)
    (list (cons 'operator (first prefix-exp))
          (annotate-ne (second prefix-exp))
          (annotate-ne (third prefix-exp)))))

(define annotate-ne
  (lambda (number-exp)
    (if (number? number-exp)
        number-exp
        (annotate number-exp))))

;; ---------------------------------------------------------------------
;; slist-contains?

(define slist-contains?
  (lambda (s slst)
    (if (null? slst)
        #f
        (or (se-contains? s (first slst))
            (slist-contains? s (rest slst))))))

(define se-contains?
  (lambda (s symexp)
    (if (symbol? symexp)
        (eq? s symexp)
        (slist-contains? s symexp))))

;; ---------------------------------------------------------------------
;; contains-varref?

(define contains-varref?
  (lambda (v exp)
    (cond ((varref? exp) (eq? v exp))
          ((lambda? exp) (contains-varref? v (lambda->body exp)))
          ((app? exp) (or (contains-varref? v (app->proc exp))
                          (contains-varref? v (app->arg exp))))
          (else (error 'contains-varref?)))))